#ifndef RAWEVENTHEADERV1_H
#define RAWEVENTHEADERV1_H
#include "DAQDataFormats/RawEventHeaderV0.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawEventHeader
#define  CURRENT_CLASS_VERSION        1
#define  CURRENT_FIELDS_SUB_NAMESPACE raweventhdr
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace  VERSION_NAMESPACE {
   namespace CURRENT_FIELDS_SUB_NAMESPACE {

        enum EventHeaderMASKS{
            MASK_TriggerFilled = 0x10000000, //! Is trigger filled
            MASK_TailFilled    = 0x08000000  //! Is tail filled
        };

        enum EventHeaderWORDS{
            WORD_TriggerFilled = 7,
            WORD_TailFilled    = 7
        };

        DEFINE_SHIFT_FROM_MASK(TriggerFilled)
        DEFINE_SHIFT_FROM_MASK(TailFilled   )
  }// end of namespace raweventhdr
  
    class RawEventHeader: public PREVIOUS_VERSION_CLASS_NAME {
        public:
            RawEventHeader (const version_t); ///< The default constructor
            RawEventHeader (const RawEventHeader&);
            ~RawEventHeader(); ///< Destructor

            using PREVIOUS_VERSION_CLASS_NAME::print;
            void  print (std::ostream& os=std::cout) const;

        protected:
            IMPLEMENT_FIRST_GET_AND_SET(TriggerFilled, uint32_t);
            IMPLEMENT_FIRST_GET_AND_SET(TailFilled   , uint32_t);

    };
  
  
}} // END NAMESPCE daqdataformats
#endif /* RAWEVENTHEADERV0_H */
