//  This file (RawMilliBlock.h) was created by Ron Rechenmacher <ron@fnal.gov> on
//  Oct 19, 2011. "TERMS AND CONDITIONS" governing this file are in the README
//  or COPYING file. If you do not have such a file, one can be obtained by
//  contacting Ron or Fermi Lab in Batavia IL, 60510, phone: 630-840-3000.
//  $RCSfile: RawMilliBlockHeader.h,v $
//  rev="$Revision: 1.1 $$Date: 2012/09/25 18:39:47 $";

#ifndef RAWMILLIBLOCKHEADER_H
#define RAWMILLIBLOCKHEADER_H

#include <stdint.h>             // *int*_t

struct RawMilliBlockHeader
{
    uint32_t    total_bytes;
    uint32_t    seqNum;
    uint64_t    timeStart;
    uint64_t    timeEnd;
    struct
    {   uint16_t        incomplete:1;
        uint16_t        truncated:1; // if some slcs drop b/c shm too small
      uint16_t  overflowCorruption:1;
        uint16_t        unused:13;
        int16_t         expected_count; // for Far Detector, the number is expected to be 198
    }           flags;
    uint32_t    millislice_count;
    // the first RawMilliSlice follow immediately after the end of this structure in memory
};

#endif // RAWMILLIBLOCKHEADER_H
