#ifndef RAWSUMMARYDCMDATAHEADERV0_H
#define RAWSUMMARYDCMDATAHEADERV0_H
#include "DAQDataFormats/RawDAQData.h"
#include "DAQDataFormats/Macros.h"
#include "DAQDataFormats/BitFields.h"
#include "DAQDataFormats/RawDCMChan.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawSummaryDCMDataHeader
#define  CURRENT_CLASS_VERSION        0
#define  CURRENT_FIELDS_SUB_NAMESPACE summarydcmdatahdr
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace  VERSION_NAMESPACE {
            namespace CURRENT_FIELDS_SUB_NAMESPACE {
        
                static const uint32_t RAWSUMMARYDCMDATAHEADER_SIZE          = 2;
            
                enum SummaryDCMDataHeaderMASKS{
		  MASK_Version    = 0xFF000000,
		  MASK_NumEntries = 0xFFFFFFFF
                };

                enum SummaryDCMDataHeaderWORDS{
                    WORD_Version    = 0,
                    WORD_NumEntries = 1,
                };

                DEFINE_SHIFT_FROM_MASK(Version);
                DEFINE_SHIFT_FROM_MASK(NumEntries);
            }// end of namespace rawmicroblockhdr
    


  class RawSummaryDCMDataHeader: public PREVIOUS_VERSION_CLASS_NAME {

        public:

            // Constructors
            RawSummaryDCMDataHeader(const version_t);
            RawSummaryDCMDataHeader(const RawSummaryDCMDataHeader&);
            ~RawSummaryDCMDataHeader();

            void     init           ();
            using    PREVIOUS_VERSION_CLASS_NAME::print;
            void     print          (std::ostream& os=std::cout) const;
            uint32_t sizeofdata     () const {return CURRENT_FIELDS_SUB_NAMESPACE::RAWSUMMARYDCMDATAHEADER_SIZE;}

            /// RawSummaryDCMDataHeader is a fixed size format
            using    RawDAQData::readData;
            void*    readData(const void* pointer){return RawDAQData::readDataGeneral(pointer);};

        protected:

	      IMPLEMENT_FIRST_GET_AND_SET(Version, uint32_t)
            IMPLEMENT_FIRST_GET_AND_SET(NumEntries, uint32_t)

	      INIT_FIRST(advanceNumEntries, , bool, )
  };


}} // END NAMESPCE daqdataformats
#endif /* RAWSUMMARYDCMDATAHEADERV0_H */
