#ifndef RAWSUMMARYDCMDATAPOINTV0_H
#define RAWSUMMARYDCMDATAPOINTV0_H

#include "DAQDataFormats/RawDAQData.h"
#include "DAQDataFormats/Macros.h"
#include "DAQDataFormats/BitFields.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawSummaryDCMDataPoint
#define  CURRENT_CLASS_VERSION        0
#define  CURRENT_FIELDS_SUB_NAMESPACE summarydcmdatapoint
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {

  enum DCMDataPointType {
    DCMDataPointType_MissingDCM = 0,
    DCMDataPointType_MissingMicroslice = 1,
    DCMDataPointType_CorruptMicroslice = 2
  };

  namespace  VERSION_NAMESPACE {

        namespace CURRENT_FIELDS_SUB_NAMESPACE {

            static const uint32_t  RAWSUMMARYDCMDATAPOINT_SIZE = 3;

            enum DCMDataPointWORDS{
	      WORD_Version = 0,
	      WORD_DataType = 0,
	      WORD_DCMID = 0,
                WORD_TimeStampLow  = 1,
                WORD_TimeStampHigh = 2
            };
            enum DCMDataPointMASKS{
	      MASK_Version = 0xFF000000,
	      MASK_DataType    = 0x00FF0000,
	      MASK_DCMID   = 0x0000FFFF,
                MASK_TimeStampLow    = 0xFFFFFFFF,
                MASK_TimeStampHigh   = 0xFFFFFFFF
            };

            DEFINE_SHIFT_FROM_MASK(DCMID);
            DEFINE_SHIFT_FROM_MASK(DataType   );
                DEFINE_SHIFT_FROM_MASK(TimeStampLow)
		DEFINE_SHIFT_FROM_MASK(TimeStampHigh)
                DEFINE_SHIFT_FROM_MASK(Version)

        };// end of namespace rawnano


  class RawSummaryDCMDataPoint: public PREVIOUS_VERSION_CLASS_NAME {
    
        public:
            // Constructors
            RawSummaryDCMDataPoint (const version_t);
            RawSummaryDCMDataPoint (const RawSummaryDCMDataPoint&);
            /// Destructor
            ~RawSummaryDCMDataPoint();

            void     init            ();
            using    PREVIOUS_VERSION_CLASS_NAME::print;
            void     print           (std::ostream& os=std::cout) const;
            uint32_t sizeofdata      () const { return CURRENT_FIELDS_SUB_NAMESPACE::RAWSUMMARYDCMDATAPOINT_SIZE;}

            /// Nanoslice of version 0 is a fixed size format
            using    RawDAQData::readData;
            void*    readData(const void* pointer){return RawDAQData::readDataGeneral(pointer);};

        protected:
            IMPLEMENT_FIRST_GET_AND_SET(Version, uint32_t)
	      IMPLEMENT_FIRST_GET_AND_SET(DataType, uint32_t)
	      IMPLEMENT_FIRST_GET_AND_SET(DCMID, uint32_t)	      
            IMPLEMENT_FIRST_GET_AND_SET(TimeStampLow  , uint32_t)	      
            IMPLEMENT_FIRST_GET_AND_SET(TimeStampHigh  , uint32_t)

	      INIT_FIRST(getTimeStamp, const, uint64_t, )
	      INIT_FIRST(setTimeStamp, , bool, const uint64_t )

    };// end of RawSummaryDCMDataPoint
  
  
}} // END NAMESPCE daqdataformats
#endif /* RAWNANOSLICEV0_H */
