#ifndef RAWSUMMARYDROPPEDMICROBLOCKV0_H
#define RAWSUMMARYDROPPEDMICROBLOCKV0_H

#include "DAQDataFormats/RawDAQData.h"
#include "DAQDataFormats/Macros.h"
#include "DAQDataFormats/BitFields.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawSummaryDroppedMicroblock
#define  CURRENT_CLASS_VERSION        0
#define  CURRENT_FIELDS_SUB_NAMESPACE summarydroppedmicroblock
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {

  namespace  VERSION_NAMESPACE {

    namespace CURRENT_FIELDS_SUB_NAMESPACE {

                static const uint32_t SUMMARYDROPPEDMICROBLOCK_SIZE = 5;

                enum SummaryDroppedMicroblockMASKS{
                  MASK_TimeStampLow    = 0xFFFFFFFF,
                  MASK_TimeStampHigh   = 0x00FFFFFF,
                  MASK_Version         = 0xFF000000,
                  MASK_TimeWindow_sec  = 0xFFF00000,
                  MASK_TimeWindow_usec = 0x000FFFFF,
                  MASK_NumDroppedMicroblocks = 0xFFFFFFFF
                };
        
                enum SummaryDroppedMicroblockWORDS{
                    WORD_TimeStampLow             = 0,
                    WORD_TimeStampHigh            = 1,
                    WORD_Version                  = 1,
                    WORD_TimeWindow_sec           = 2,
                    WORD_TimeWindow_usec          = 2,
                    WORD_NumDroppedMicroblocks    = 3
                };

                DEFINE_SHIFT_FROM_MASK(TimeStampLow)
		DEFINE_SHIFT_FROM_MASK(TimeStampHigh)
                DEFINE_SHIFT_FROM_MASK(Version)
		DEFINE_SHIFT_FROM_MASK(TimeWindow_sec)
		DEFINE_SHIFT_FROM_MASK(TimeWindow_usec)
		DEFINE_SHIFT_FROM_MASK(NumDroppedMicroblocks)

    }// end of namespace summarydroppedmicroblock
      
    class RawSummaryDroppedMicroblock: public PREVIOUS_VERSION_CLASS_NAME {

        public:

            RawSummaryDroppedMicroblock (const version_t); ///< The default constructor
            RawSummaryDroppedMicroblock (const RawSummaryDroppedMicroblock&);
            ~RawSummaryDroppedMicroblock (); ///< Destructor

            void     init            ();
            using    PREVIOUS_VERSION_CLASS_NAME::print;
            void     print           (std::ostream& os=std::cout) const;
            uint32_t sizeofdata      () const { return CURRENT_FIELDS_SUB_NAMESPACE::SUMMARYDROPPEDMICROBLOCK_SIZE;}
            using    RawDAQData::readData;
            void*    readData(const void* pointer){return RawDAQData::readDataGeneral(pointer);};

    protected:

            IMPLEMENT_FIRST_GET_AND_SET(Version, uint32_t)
            IMPLEMENT_FIRST_GET_AND_SET(TimeStampLow, uint32_t)
            IMPLEMENT_FIRST_GET_AND_SET(TimeStampHigh, uint32_t)
            IMPLEMENT_FIRST_GET_AND_SET(TimeWindow_sec, uint32_t)
            IMPLEMENT_FIRST_GET_AND_SET(TimeWindow_usec, uint32_t)
            IMPLEMENT_FIRST_GET_AND_SET(NumDroppedMicroblocks, uint32_t)

	    INIT_FIRST(getTimeStamp, const, uint64_t, )
	    INIT_FIRST(setTimeStamp,      , bool , const uint64_t )
            
	    INIT_FIRST(getTimeWindowTvUsec, const, suseconds_t, )
	    INIT_FIRST(setTimeWindowTvUsec,      , bool, const suseconds_t )
	    INIT_FIRST(getTimeWindowTvSec, const, time_t, )
	    INIT_FIRST(setTimeWindowTvSec,    , bool, const time_t )  
	    INIT_FIRST(getTimeWindowTv, const, timeval, )
	    INIT_FIRST(setTimeWindowTv,    , bool, const timeval ) 
    };
  
    
  }
} // END NAMESPACE daqdataformats

#endif /* RAWSUMMARYDROPPEDMICROBLOCKV0_H */
