#ifndef _RMS_THREADWRAPPER_H
#define _RMS_THREADWRAPPER_H

#include <rms/util/Runnable.h>

namespace gov {

namespace fnal {

namespace cd {

namespace rms {

namespace util {

/**
 * Simple class for helping to create Boost Threads.
 *
 * Sample usage:
 * <code>
 * RunnableDescendant myRunnable;
 * boost::thread
 *   myThread(boost::bind(gov::fnal::cd::rms::util::ThreadWrapper::execute,
 *                        &myRunnable));
 * </code>
 *
 * @author Kurt Biery
 * @author Steve Foulkes
 * @version $Revision: 1.1.1.1 $ $Date: 2009/10/09 20:03:00 $
 */

class ThreadWrapper {
 public:    
    /**
     * Executes the run method of the specified Runnable object.
     */
    static void execute(Runnable *runnableObject) {
        runnableObject->run();
    }

};

};  // end of namespace util

};  // end of namespace rms

};  // end of namespace cd

};  // end of namespace fnal

};  // end of namespace gov

#endif
