#include "DAQDataFormats/RawConfigurationTail.h"
#include "DAQDataFormats/DataFormatException.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawConfigurationTail
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE rawconftail
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats{

//------------------------------------------------------------------------------
RawConfigurationTail::RawConfigurationTail(const version_t version):
    PREVIOUS_VERSION_CLASS_NAME(version)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    /// Perform general routines
    defaultConstructorFixedSize();
}

//------------------------------------------------------------------------------
RawConfigurationTail::RawConfigurationTail(const RawConfigurationTail& copy_in):
    PREVIOUS_VERSION_CLASS_NAME(copy_in)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    lastOperationsInDeepCopy(copy_in);
}

//------------------------------------------------------------------------------
RawConfigurationTail::RawConfigurationTail(const void* datablockheader_buffer, const version_t version):
    PREVIOUS_VERSION_CLASS_NAME(version)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    copy(datablockheader_buffer);
}

//------------------------------------------------------------------------------
// Destructor
RawConfigurationTail::~RawConfigurationTail() { }

/// All binding routines
#define STANDARD_ROUTINES                                    \
            BIND_GET_AND_SET(Version   , version0, uint32_t);\
            BIND_GET_AND_SET(Reserved1 , version0, uint32_t);\
            BIND_GET_AND_SET(Reserved2 , version0, uint32_t);\
            BIND_GET_AND_SET(MarkerLo1 , version0, uint32_t);\
            BIND_GET_AND_SET(MarkerLo2 , version0, uint32_t);\
            BIND_GET_AND_SET(CRC       , version0, uint32_t);\
            BIND_STADARD_FUNCTION(sizeofdata);               \
            BIND_STADARD_FUNCTIONS

#include "DAQDataFormats/setFunctionPointers_template.inc"



}// end of namespace