#include "DAQDataFormats/RawMilliSliceIndexHeader.h"
#include "DAQDataFormats/DataFormatException.h"
#include "DAQDataFormats/FunctionBind.h"

namespace daqdataformats{

//------------------------Constructors------------------------------------------
/// After this constructor the buffer pointer is set to the internal source
RawMilliSliceIndexHeader::RawMilliSliceIndexHeader():
    RawDAQData(0, (const sizeofdata_t)&RawMilliSliceIndexHeader::sizeofdata)
{

   /// Apply the default constructor
    defaultConstructorFixedSize();
}

//------------------------------------------------------------------------------
RawMilliSliceIndexHeader::RawMilliSliceIndexHeader(const RawMilliSliceIndexHeader& copy_in):
    RawDAQData(copy_in)
{
    lastOperationsInDeepCopy(copy_in);
}

//------------------------------------------------------------------------------
// Constructing the nanoslice header form a pointer to an existing nanoslice header
RawMilliSliceIndexHeader::RawMilliSliceIndexHeader(const void* nanosliceheader_buffer):
    RawDAQData(0, (const sizeofdata_t)&RawMilliSliceIndexHeader::sizeofdata)
{
   /// Use default Shallow copy constructor
    copy(nanosliceheader_buffer);
}

//------------------------Destructor--------------------------------------------
RawMilliSliceIndexHeader::~RawMilliSliceIndexHeader() { }


}// end of namespace