#include "DAQDataFormats/RawSummaryDCMData.h"
#include "DAQDataFormats/DataFormatException.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawSummaryDCMData
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE summarydcmdata
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats{

//------------------------------------------------------------------------------
// Default constructor
  RawSummaryDCMData::RawSummaryDCMData(const version_t version):
    PREVIOUS_VERSION_CLASS_NAME(version)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    reserveInternalBuffer(DEFAULT_DCMDATA_SIZE);
    defaultConstructorFloatingSize();
}
//------------------------------------------------------------------------------
RawSummaryDCMData::RawSummaryDCMData(const RawSummaryDCMData& copy_in):
    PREVIOUS_VERSION_CLASS_NAME(copy_in)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    lastOperationsInDeepCopy(copy_in);
}

//------------------------------------------------------------------------------
RawSummaryDCMData::RawSummaryDCMData(const void* buffer, const version_t version, const uint32_t buffersize):
    PREVIOUS_VERSION_CLASS_NAME(version)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    reserveInternalBuffer(buffersize);
    copy(buffer);
}
//------------------------------------------------------------------------------
// Destructor
RawSummaryDCMData::~RawSummaryDCMData() { }

/// All binding routines
#define STANDARD_ROUTINES                           \
            BIND_GET(Version , version0, uint32_t);\
  BIND_CUSTOM_FUNCTION(addDataPoints, version0, , bool, const std::list< std::pair< uint64_t, uint16_t> >&, uint8_t); \
            BIND_STADARD_FUNCTION(setBufferSource); \
  BIND_STADARD_FUNCTION(sizeofdata) \
            BIND_STADARD_FUNCTIONS                  

#include "DAQDataFormats/setFunctionPointers_template.inc"



} // end of namespace
