#include "DAQMessages/ErrorHandlerMessagesDcps_impl.h"
#include "gapi.h"
#include "gapi_loanRegistry.h"
#include "DAQMessages/ErrorHandlerMessagesSplDcps.h"
#include "ccpp_DataReader_impl.h"
#include "ccpp_DataReaderView_impl.h"


extern c_bool
__errorhandlermessages_ErrorHandlerMessage__copyIn(
    c_base base,
    struct errorhandlermessages::ErrorHandlerMessage *from,
    struct _errorhandlermessages_ErrorHandlerMessage *to);

extern void
__errorhandlermessages_ErrorHandlerMessage__copyOut(
    void *_from,
    void *_to);

// DDS errorhandlermessages::ErrorHandlerMessage TypeSupportFactory Object Body

 DDS::DataWriter_ptr 
errorhandlermessages::ErrorHandlerMessageTypeSupportFactory::create_datawriter (gapi_dataWriter handle)
{
    return new errorhandlermessages::ErrorHandlerMessageDataWriter_impl(handle);
}

 DDS::DataReader_ptr 
errorhandlermessages::ErrorHandlerMessageTypeSupportFactory::create_datareader (gapi_dataReader handle)
{
    return new errorhandlermessages::ErrorHandlerMessageDataReader_impl (handle);
}


 DDS::DataReaderView_ptr 
errorhandlermessages::ErrorHandlerMessageTypeSupportFactory::create_view (gapi_dataReaderView handle)
{
    return new errorhandlermessages::ErrorHandlerMessageDataReaderView_impl (handle);
}

// DDS errorhandlermessages::ErrorHandlerMessage TypeSupport Object Body

 errorhandlermessages::ErrorHandlerMessageTypeSupport::ErrorHandlerMessageTypeSupport(void) :
    TypeSupport_impl(
        __errorhandlermessages_ErrorHandlerMessage__name(),
        __errorhandlermessages_ErrorHandlerMessage__keys(),
        errorhandlermessages::ErrorHandlerMessageTypeSupport::metaDescriptor,
        (gapi_copyIn) __errorhandlermessages_ErrorHandlerMessage__copyIn,
        (gapi_copyOut) __errorhandlermessages_ErrorHandlerMessage__copyOut,
        (gapi_readerCopy) DDS::ccpp_DataReaderCopy<errorhandlermessages::ErrorHandlerMessageSeq, errorhandlermessages::ErrorHandlerMessage>,
        new  errorhandlermessages::ErrorHandlerMessageTypeSupportFactory())
{
    // Parent constructor takes care of everything.
}

 errorhandlermessages::ErrorHandlerMessageTypeSupport::~ErrorHandlerMessageTypeSupport(void)
{
    // Parent destructor takes care of everything.
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageTypeSupport::register_type(
    DDS::DomainParticipant_ptr domain,
    const char * type_name) THROW_ORB_EXCEPTIONS
{
    return TypeSupport_impl::register_type(domain, type_name);
}

 char *
errorhandlermessages::ErrorHandlerMessageTypeSupport::get_type_name() THROW_ORB_EXCEPTIONS
{
    return TypeSupport_impl::get_type_name();
}

// DDS errorhandlermessages::ErrorHandlerMessage DataWriter_impl Object Body

 errorhandlermessages::ErrorHandlerMessageDataWriter_impl::ErrorHandlerMessageDataWriter_impl (
    gapi_dataWriter handle
) : DDS::DataWriter_impl(handle)
{
    // Parent constructor takes care of everything.
}

 errorhandlermessages::ErrorHandlerMessageDataWriter_impl::~ErrorHandlerMessageDataWriter_impl(void)
{
    // Parent destructor takes care of everything.
}

 DDS::InstanceHandle_t
errorhandlermessages::ErrorHandlerMessageDataWriter_impl::register_instance(
    const errorhandlermessages::ErrorHandlerMessage & instance_data) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::register_instance(&instance_data);
}

 DDS::InstanceHandle_t 
errorhandlermessages::ErrorHandlerMessageDataWriter_impl::register_instance_w_timestamp(
    const ErrorHandlerMessage & instance_data,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::register_instance_w_timestamp(&instance_data, source_timestamp);
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataWriter_impl::unregister_instance(
    const errorhandlermessages::ErrorHandlerMessage & instance_data,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::unregister_instance(&instance_data, handle);
}

 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerMessageDataWriter_impl::unregister_instance_w_timestamp(
    const ErrorHandlerMessage & instance_data,
    DDS::InstanceHandle_t handle,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::unregister_instance_w_timestamp(&instance_data, handle, source_timestamp);
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataWriter_impl::write(
    const errorhandlermessages::ErrorHandlerMessage & instance_data,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::write(&instance_data, handle);
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataWriter_impl::write_w_timestamp(
    const ErrorHandlerMessage & instance_data,
    DDS::InstanceHandle_t handle,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::write_w_timestamp(&instance_data, handle, source_timestamp);
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataWriter_impl::dispose(
    const errorhandlermessages::ErrorHandlerMessage & instance_data,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::dispose(&instance_data, handle);
}

 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerMessageDataWriter_impl::dispose_w_timestamp(
    const ErrorHandlerMessage & instance_data,
    DDS::InstanceHandle_t handle,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::dispose_w_timestamp(&instance_data, handle, source_timestamp);
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataWriter_impl::writedispose(
    const errorhandlermessages::ErrorHandlerMessage & instance_data,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::writedispose(&instance_data, handle);
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataWriter_impl::writedispose_w_timestamp(
    const ErrorHandlerMessage & instance_data,
    DDS::InstanceHandle_t handle,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::writedispose_w_timestamp(&instance_data, handle, source_timestamp);
}

 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerMessageDataWriter_impl::get_key_value(
    ErrorHandlerMessage & key_holder,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::get_key_value(&key_holder, handle);
}

 DDS::InstanceHandle_t 
errorhandlermessages::ErrorHandlerMessageDataWriter_impl::lookup_instance(
	const errorhandlermessages::ErrorHandlerMessage & instance_data) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::lookup_instance(&instance_data);
}

// DDS errorhandlermessages::ErrorHandlerMessage DataReader_impl Object Body

 errorhandlermessages::ErrorHandlerMessageDataReader_impl::ErrorHandlerMessageDataReader_impl (
    gapi_dataReader handle
) : DDS::DataReader_impl(handle)
{
    // Parent constructor takes care of everything.
}

 errorhandlermessages::ErrorHandlerMessageDataReader_impl::~ErrorHandlerMessageDataReader_impl(void)
{
    // Parent destructor takes care of everything.
}


 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataReader_impl::read(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read(&received_data, info_seq, max_samples, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataReader_impl::take(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take(&received_data, info_seq, max_samples, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataReader_impl::read_w_condition(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read_w_condition(&received_data, info_seq, max_samples, a_condition);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataReader_impl::take_w_condition(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take_w_condition(&received_data, info_seq, max_samples, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerMessageDataReader_impl::read_next_sample(
    errorhandlermessages::ErrorHandlerMessage & received_data,
    DDS::SampleInfo & sample_info) THROW_ORB_EXCEPTIONS
{
    return DataReader_impl::read_next_sample(&received_data, sample_info);
}


 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerMessageDataReader_impl::take_next_sample(
    errorhandlermessages::ErrorHandlerMessage & received_data,
    DDS::SampleInfo & sample_info) THROW_ORB_EXCEPTIONS
{
    return DataReader_impl::take_next_sample(&received_data, sample_info);
}


 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataReader_impl::read_instance(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataReader_impl::take_instance(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataReader_impl::read_next_instance(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read_next_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataReader_impl::take_next_instance(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take_next_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}


 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerMessageDataReader_impl::read_next_instance_w_condition(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read_next_instance_w_condition(&received_data, info_seq, max_samples, a_handle, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerMessageDataReader_impl::take_next_instance_w_condition(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take_next_instance_w_condition(&received_data, info_seq, max_samples, a_handle, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataReader_impl::return_loan(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status = DDS::RETCODE_OK;

    if ( received_data.length() > 0 ) {
        if (received_data.length() == info_seq.length() && 
            received_data.release() == info_seq.release() ) {
            if (!received_data.release()) {
                status = DataReader_impl::return_loan( received_data.get_buffer(),
                                                       info_seq.get_buffer() );

                if ( status == DDS::RETCODE_OK ) {
                    if ( !received_data.release() ) {
                        errorhandlermessages::ErrorHandlerMessageSeq::freebuf( received_data.get_buffer(false) );
                        received_data.replace(0, 0, NULL, false);
                        DDS::SampleInfoSeq::freebuf( info_seq.get_buffer(false) );
                        info_seq.replace(0, 0, NULL, false);
                    }
                } else if ( status == DDS::RETCODE_NO_DATA ) {
                    if ( received_data.release() ) {
                        status = DDS::RETCODE_OK;
                    } else {
                        status = DDS::RETCODE_PRECONDITION_NOT_MET;
                    }
                }
            }
        } else {
            status = DDS::RETCODE_PRECONDITION_NOT_MET;
        }
    }
    return status;
}


 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerMessageDataReader_impl::get_key_value(
    errorhandlermessages::ErrorHandlerMessage & key_holder,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataReader_impl::get_key_value(&key_holder, handle);
}

 DDS::InstanceHandle_t 
errorhandlermessages::ErrorHandlerMessageDataReader_impl::lookup_instance(
    const errorhandlermessages::ErrorHandlerMessage & instance) THROW_ORB_EXCEPTIONS
{
    return DataReader_impl::lookup_instance(&instance);
}

 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerMessageDataReader_impl::check_preconditions(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples)
{
    DDS::ReturnCode_t status = DDS::RETCODE_PRECONDITION_NOT_MET;
    
    if ( received_data.length() == info_seq.length() &&
         received_data.maximum() == info_seq.maximum() &&
         received_data.release() == info_seq.release() ) {
        if ( received_data.maximum() == 0 || received_data.release() ) {
            if (received_data.maximum() == 0 ||
				max_samples <= static_cast<CORBA::Long>(received_data.maximum()) ||
				max_samples == DDS::LENGTH_UNLIMITED ) {
                status = DDS::RETCODE_OK;
            }
        }
    }
    return status;
}


// DDS errorhandlermessages::ErrorHandlerMessage DataReaderView_impl Object Body

 errorhandlermessages::ErrorHandlerMessageDataReaderView_impl::ErrorHandlerMessageDataReaderView_impl (
    gapi_dataReaderView handle
) : DDS::DataReaderView_impl(handle)
{
    // Parent constructor takes care of everything.
}

 errorhandlermessages::ErrorHandlerMessageDataReaderView_impl::~ErrorHandlerMessageDataReaderView_impl(void)
{
    // Parent destructor takes care of everything.
}


 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataReaderView_impl::read(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = errorhandlermessages::ErrorHandlerMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read(&received_data, info_seq, max_samples, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataReaderView_impl::take(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = errorhandlermessages::ErrorHandlerMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take(&received_data, info_seq, max_samples, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataReaderView_impl::read_w_condition(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = errorhandlermessages::ErrorHandlerMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read_w_condition(&received_data, info_seq, max_samples, a_condition);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataReaderView_impl::take_w_condition(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = errorhandlermessages::ErrorHandlerMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take_w_condition(&received_data, info_seq, max_samples, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerMessageDataReaderView_impl::read_next_sample(
    errorhandlermessages::ErrorHandlerMessage & received_data,
    DDS::SampleInfo & sample_info) THROW_ORB_EXCEPTIONS
{
    return DataReaderView_impl::read_next_sample(&received_data, sample_info);
}


 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerMessageDataReaderView_impl::take_next_sample(
    errorhandlermessages::ErrorHandlerMessage & received_data,
    DDS::SampleInfo & sample_info) THROW_ORB_EXCEPTIONS
{
    return DataReaderView_impl::take_next_sample(&received_data, sample_info);
}


 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataReaderView_impl::read_instance(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = errorhandlermessages::ErrorHandlerMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataReaderView_impl::take_instance(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = errorhandlermessages::ErrorHandlerMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataReaderView_impl::read_next_instance(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = errorhandlermessages::ErrorHandlerMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read_next_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataReaderView_impl::take_next_instance(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = errorhandlermessages::ErrorHandlerMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take_next_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}


 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerMessageDataReaderView_impl::read_next_instance_w_condition(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = errorhandlermessages::ErrorHandlerMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read_next_instance_w_condition(&received_data, info_seq, max_samples, a_handle, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerMessageDataReaderView_impl::take_next_instance_w_condition(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = errorhandlermessages::ErrorHandlerMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take_next_instance_w_condition(&received_data, info_seq, max_samples, a_handle, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerMessageDataReaderView_impl::return_loan(
    errorhandlermessages::ErrorHandlerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status = DDS::RETCODE_OK;

    if ( received_data.length() > 0 ) {
        if (received_data.length() == info_seq.length() && 
            received_data.release() == info_seq.release() ) {
            if (!received_data.release()) {
                status = DataReaderView_impl::return_loan( received_data.get_buffer(),
                                                       info_seq.get_buffer() );

                if ( status == DDS::RETCODE_OK ) {
                    if ( !received_data.release() ) {
                        errorhandlermessages::ErrorHandlerMessageSeq::freebuf( received_data.get_buffer(false) );
                        received_data.replace(0, 0, NULL, false);
                        DDS::SampleInfoSeq::freebuf( info_seq.get_buffer(false) );
                        info_seq.replace(0, 0, NULL, false);
                    }
                } else if ( status == DDS::RETCODE_NO_DATA ) {
                    if ( received_data.release() ) {
                        status = DDS::RETCODE_OK;
                    } else {
                        status = DDS::RETCODE_PRECONDITION_NOT_MET;
                    }
                }
            }
        } else {
            status = DDS::RETCODE_PRECONDITION_NOT_MET;
        }
    }
    return status;
}


 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerMessageDataReaderView_impl::get_key_value(
    errorhandlermessages::ErrorHandlerMessage & key_holder,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataReaderView_impl::get_key_value(&key_holder, handle);
}

 DDS::InstanceHandle_t 
errorhandlermessages::ErrorHandlerMessageDataReaderView_impl::lookup_instance(
    const errorhandlermessages::ErrorHandlerMessage & instance) THROW_ORB_EXCEPTIONS
{
    return DataReaderView_impl::lookup_instance(&instance);
}



extern c_bool
__errorhandlermessages_ErrorHandlerReply__copyIn(
    c_base base,
    struct errorhandlermessages::ErrorHandlerReply *from,
    struct _errorhandlermessages_ErrorHandlerReply *to);

extern void
__errorhandlermessages_ErrorHandlerReply__copyOut(
    void *_from,
    void *_to);

// DDS errorhandlermessages::ErrorHandlerReply TypeSupportFactory Object Body

 DDS::DataWriter_ptr 
errorhandlermessages::ErrorHandlerReplyTypeSupportFactory::create_datawriter (gapi_dataWriter handle)
{
    return new errorhandlermessages::ErrorHandlerReplyDataWriter_impl(handle);
}

 DDS::DataReader_ptr 
errorhandlermessages::ErrorHandlerReplyTypeSupportFactory::create_datareader (gapi_dataReader handle)
{
    return new errorhandlermessages::ErrorHandlerReplyDataReader_impl (handle);
}


 DDS::DataReaderView_ptr 
errorhandlermessages::ErrorHandlerReplyTypeSupportFactory::create_view (gapi_dataReaderView handle)
{
    return new errorhandlermessages::ErrorHandlerReplyDataReaderView_impl (handle);
}

// DDS errorhandlermessages::ErrorHandlerReply TypeSupport Object Body

 errorhandlermessages::ErrorHandlerReplyTypeSupport::ErrorHandlerReplyTypeSupport(void) :
    TypeSupport_impl(
        __errorhandlermessages_ErrorHandlerReply__name(),
        __errorhandlermessages_ErrorHandlerReply__keys(),
        errorhandlermessages::ErrorHandlerReplyTypeSupport::metaDescriptor,
        (gapi_copyIn) __errorhandlermessages_ErrorHandlerReply__copyIn,
        (gapi_copyOut) __errorhandlermessages_ErrorHandlerReply__copyOut,
        (gapi_readerCopy) DDS::ccpp_DataReaderCopy<errorhandlermessages::ErrorHandlerReplySeq, errorhandlermessages::ErrorHandlerReply>,
        new  errorhandlermessages::ErrorHandlerReplyTypeSupportFactory())
{
    // Parent constructor takes care of everything.
}

 errorhandlermessages::ErrorHandlerReplyTypeSupport::~ErrorHandlerReplyTypeSupport(void)
{
    // Parent destructor takes care of everything.
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyTypeSupport::register_type(
    DDS::DomainParticipant_ptr domain,
    const char * type_name) THROW_ORB_EXCEPTIONS
{
    return TypeSupport_impl::register_type(domain, type_name);
}

 char *
errorhandlermessages::ErrorHandlerReplyTypeSupport::get_type_name() THROW_ORB_EXCEPTIONS
{
    return TypeSupport_impl::get_type_name();
}

// DDS errorhandlermessages::ErrorHandlerReply DataWriter_impl Object Body

 errorhandlermessages::ErrorHandlerReplyDataWriter_impl::ErrorHandlerReplyDataWriter_impl (
    gapi_dataWriter handle
) : DDS::DataWriter_impl(handle)
{
    // Parent constructor takes care of everything.
}

 errorhandlermessages::ErrorHandlerReplyDataWriter_impl::~ErrorHandlerReplyDataWriter_impl(void)
{
    // Parent destructor takes care of everything.
}

 DDS::InstanceHandle_t
errorhandlermessages::ErrorHandlerReplyDataWriter_impl::register_instance(
    const errorhandlermessages::ErrorHandlerReply & instance_data) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::register_instance(&instance_data);
}

 DDS::InstanceHandle_t 
errorhandlermessages::ErrorHandlerReplyDataWriter_impl::register_instance_w_timestamp(
    const ErrorHandlerReply & instance_data,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::register_instance_w_timestamp(&instance_data, source_timestamp);
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataWriter_impl::unregister_instance(
    const errorhandlermessages::ErrorHandlerReply & instance_data,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::unregister_instance(&instance_data, handle);
}

 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerReplyDataWriter_impl::unregister_instance_w_timestamp(
    const ErrorHandlerReply & instance_data,
    DDS::InstanceHandle_t handle,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::unregister_instance_w_timestamp(&instance_data, handle, source_timestamp);
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataWriter_impl::write(
    const errorhandlermessages::ErrorHandlerReply & instance_data,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::write(&instance_data, handle);
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataWriter_impl::write_w_timestamp(
    const ErrorHandlerReply & instance_data,
    DDS::InstanceHandle_t handle,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::write_w_timestamp(&instance_data, handle, source_timestamp);
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataWriter_impl::dispose(
    const errorhandlermessages::ErrorHandlerReply & instance_data,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::dispose(&instance_data, handle);
}

 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerReplyDataWriter_impl::dispose_w_timestamp(
    const ErrorHandlerReply & instance_data,
    DDS::InstanceHandle_t handle,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::dispose_w_timestamp(&instance_data, handle, source_timestamp);
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataWriter_impl::writedispose(
    const errorhandlermessages::ErrorHandlerReply & instance_data,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::writedispose(&instance_data, handle);
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataWriter_impl::writedispose_w_timestamp(
    const ErrorHandlerReply & instance_data,
    DDS::InstanceHandle_t handle,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::writedispose_w_timestamp(&instance_data, handle, source_timestamp);
}

 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerReplyDataWriter_impl::get_key_value(
    ErrorHandlerReply & key_holder,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::get_key_value(&key_holder, handle);
}

 DDS::InstanceHandle_t 
errorhandlermessages::ErrorHandlerReplyDataWriter_impl::lookup_instance(
	const errorhandlermessages::ErrorHandlerReply & instance_data) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::lookup_instance(&instance_data);
}

// DDS errorhandlermessages::ErrorHandlerReply DataReader_impl Object Body

 errorhandlermessages::ErrorHandlerReplyDataReader_impl::ErrorHandlerReplyDataReader_impl (
    gapi_dataReader handle
) : DDS::DataReader_impl(handle)
{
    // Parent constructor takes care of everything.
}

 errorhandlermessages::ErrorHandlerReplyDataReader_impl::~ErrorHandlerReplyDataReader_impl(void)
{
    // Parent destructor takes care of everything.
}


 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataReader_impl::read(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read(&received_data, info_seq, max_samples, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataReader_impl::take(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take(&received_data, info_seq, max_samples, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataReader_impl::read_w_condition(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read_w_condition(&received_data, info_seq, max_samples, a_condition);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataReader_impl::take_w_condition(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take_w_condition(&received_data, info_seq, max_samples, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerReplyDataReader_impl::read_next_sample(
    errorhandlermessages::ErrorHandlerReply & received_data,
    DDS::SampleInfo & sample_info) THROW_ORB_EXCEPTIONS
{
    return DataReader_impl::read_next_sample(&received_data, sample_info);
}


 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerReplyDataReader_impl::take_next_sample(
    errorhandlermessages::ErrorHandlerReply & received_data,
    DDS::SampleInfo & sample_info) THROW_ORB_EXCEPTIONS
{
    return DataReader_impl::take_next_sample(&received_data, sample_info);
}


 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataReader_impl::read_instance(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataReader_impl::take_instance(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataReader_impl::read_next_instance(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read_next_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataReader_impl::take_next_instance(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take_next_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}


 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerReplyDataReader_impl::read_next_instance_w_condition(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read_next_instance_w_condition(&received_data, info_seq, max_samples, a_handle, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerReplyDataReader_impl::take_next_instance_w_condition(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take_next_instance_w_condition(&received_data, info_seq, max_samples, a_handle, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataReader_impl::return_loan(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status = DDS::RETCODE_OK;

    if ( received_data.length() > 0 ) {
        if (received_data.length() == info_seq.length() && 
            received_data.release() == info_seq.release() ) {
            if (!received_data.release()) {
                status = DataReader_impl::return_loan( received_data.get_buffer(),
                                                       info_seq.get_buffer() );

                if ( status == DDS::RETCODE_OK ) {
                    if ( !received_data.release() ) {
                        errorhandlermessages::ErrorHandlerReplySeq::freebuf( received_data.get_buffer(false) );
                        received_data.replace(0, 0, NULL, false);
                        DDS::SampleInfoSeq::freebuf( info_seq.get_buffer(false) );
                        info_seq.replace(0, 0, NULL, false);
                    }
                } else if ( status == DDS::RETCODE_NO_DATA ) {
                    if ( received_data.release() ) {
                        status = DDS::RETCODE_OK;
                    } else {
                        status = DDS::RETCODE_PRECONDITION_NOT_MET;
                    }
                }
            }
        } else {
            status = DDS::RETCODE_PRECONDITION_NOT_MET;
        }
    }
    return status;
}


 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerReplyDataReader_impl::get_key_value(
    errorhandlermessages::ErrorHandlerReply & key_holder,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataReader_impl::get_key_value(&key_holder, handle);
}

 DDS::InstanceHandle_t 
errorhandlermessages::ErrorHandlerReplyDataReader_impl::lookup_instance(
    const errorhandlermessages::ErrorHandlerReply & instance) THROW_ORB_EXCEPTIONS
{
    return DataReader_impl::lookup_instance(&instance);
}

 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerReplyDataReader_impl::check_preconditions(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples)
{
    DDS::ReturnCode_t status = DDS::RETCODE_PRECONDITION_NOT_MET;
    
    if ( received_data.length() == info_seq.length() &&
         received_data.maximum() == info_seq.maximum() &&
         received_data.release() == info_seq.release() ) {
        if ( received_data.maximum() == 0 || received_data.release() ) {
            if (received_data.maximum() == 0 ||
				max_samples <= static_cast<CORBA::Long>(received_data.maximum()) ||
				max_samples == DDS::LENGTH_UNLIMITED ) {
                status = DDS::RETCODE_OK;
            }
        }
    }
    return status;
}


// DDS errorhandlermessages::ErrorHandlerReply DataReaderView_impl Object Body

 errorhandlermessages::ErrorHandlerReplyDataReaderView_impl::ErrorHandlerReplyDataReaderView_impl (
    gapi_dataReaderView handle
) : DDS::DataReaderView_impl(handle)
{
    // Parent constructor takes care of everything.
}

 errorhandlermessages::ErrorHandlerReplyDataReaderView_impl::~ErrorHandlerReplyDataReaderView_impl(void)
{
    // Parent destructor takes care of everything.
}


 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataReaderView_impl::read(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = errorhandlermessages::ErrorHandlerReplyDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read(&received_data, info_seq, max_samples, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataReaderView_impl::take(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = errorhandlermessages::ErrorHandlerReplyDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take(&received_data, info_seq, max_samples, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataReaderView_impl::read_w_condition(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = errorhandlermessages::ErrorHandlerReplyDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read_w_condition(&received_data, info_seq, max_samples, a_condition);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataReaderView_impl::take_w_condition(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = errorhandlermessages::ErrorHandlerReplyDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take_w_condition(&received_data, info_seq, max_samples, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerReplyDataReaderView_impl::read_next_sample(
    errorhandlermessages::ErrorHandlerReply & received_data,
    DDS::SampleInfo & sample_info) THROW_ORB_EXCEPTIONS
{
    return DataReaderView_impl::read_next_sample(&received_data, sample_info);
}


 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerReplyDataReaderView_impl::take_next_sample(
    errorhandlermessages::ErrorHandlerReply & received_data,
    DDS::SampleInfo & sample_info) THROW_ORB_EXCEPTIONS
{
    return DataReaderView_impl::take_next_sample(&received_data, sample_info);
}


 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataReaderView_impl::read_instance(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = errorhandlermessages::ErrorHandlerReplyDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataReaderView_impl::take_instance(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = errorhandlermessages::ErrorHandlerReplyDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataReaderView_impl::read_next_instance(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = errorhandlermessages::ErrorHandlerReplyDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read_next_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataReaderView_impl::take_next_instance(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = errorhandlermessages::ErrorHandlerReplyDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take_next_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}


 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerReplyDataReaderView_impl::read_next_instance_w_condition(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = errorhandlermessages::ErrorHandlerReplyDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read_next_instance_w_condition(&received_data, info_seq, max_samples, a_handle, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerReplyDataReaderView_impl::take_next_instance_w_condition(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = errorhandlermessages::ErrorHandlerReplyDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take_next_instance_w_condition(&received_data, info_seq, max_samples, a_handle, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t
errorhandlermessages::ErrorHandlerReplyDataReaderView_impl::return_loan(
    errorhandlermessages::ErrorHandlerReplySeq & received_data,
    DDS::SampleInfoSeq & info_seq) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status = DDS::RETCODE_OK;

    if ( received_data.length() > 0 ) {
        if (received_data.length() == info_seq.length() && 
            received_data.release() == info_seq.release() ) {
            if (!received_data.release()) {
                status = DataReaderView_impl::return_loan( received_data.get_buffer(),
                                                       info_seq.get_buffer() );

                if ( status == DDS::RETCODE_OK ) {
                    if ( !received_data.release() ) {
                        errorhandlermessages::ErrorHandlerReplySeq::freebuf( received_data.get_buffer(false) );
                        received_data.replace(0, 0, NULL, false);
                        DDS::SampleInfoSeq::freebuf( info_seq.get_buffer(false) );
                        info_seq.replace(0, 0, NULL, false);
                    }
                } else if ( status == DDS::RETCODE_NO_DATA ) {
                    if ( received_data.release() ) {
                        status = DDS::RETCODE_OK;
                    } else {
                        status = DDS::RETCODE_PRECONDITION_NOT_MET;
                    }
                }
            }
        } else {
            status = DDS::RETCODE_PRECONDITION_NOT_MET;
        }
    }
    return status;
}


 DDS::ReturnCode_t 
errorhandlermessages::ErrorHandlerReplyDataReaderView_impl::get_key_value(
    errorhandlermessages::ErrorHandlerReply & key_holder,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataReaderView_impl::get_key_value(&key_holder, handle);
}

 DDS::InstanceHandle_t 
errorhandlermessages::ErrorHandlerReplyDataReaderView_impl::lookup_instance(
    const errorhandlermessages::ErrorHandlerReply & instance) THROW_ORB_EXCEPTIONS
{
    return DataReaderView_impl::lookup_instance(&instance);
}



const char * ::errorhandlermessages::ErrorHandlerMessageTypeSupport::metaDescriptor = "<MetaData version=\"1.0.0\"><Module name=\"rmscore\"><Struct name=\"TimeStruct\"><Member name=\"sec\"><ULong/></Member><Member name=\"usec\"><ULong/></Member></Struct><Struct name=\"RmsMessageHeader\"><Member name=\"target\"><String/></Member><Member name=\"channel\"><String/></Member><Member name=\"replyTarget\"><String/></Member><Member name=\"id\"><String/></Member><Member name=\"correlationId\"><String/></Member><Member name=\"sentTime\"><Type name=\"rmscore::TimeStruct\"/></Member><Member name=\"correlationTime\"><Type name=\"rmscore::TimeStruct\"/></Member><Member name=\"priority\"><Long/></Member><Member name=\"partitionNumber\"><Long/></Member><Member name=\"hostName\"><String/></Member><Member name=\"applicationName\"><String/></Member></Struct></Module><Module name=\"errorhandlermessages\"><Struct name=\"ErrorHandlerMessage\"><Member name=\"header\"><Type name=\"rmscore::RmsMessageHeader\"/></Member><Member name=\"time\"><LongLong/></Member><Member name=\"error\"><Long/></Member></Struct></Module></MetaData>";
const char * ::errorhandlermessages::ErrorHandlerReplyTypeSupport::metaDescriptor = "<MetaData version=\"1.0.0\"><Module name=\"rmscore\"><Struct name=\"TimeStruct\"><Member name=\"sec\"><ULong/></Member><Member name=\"usec\"><ULong/></Member></Struct><Struct name=\"RmsMessageHeader\"><Member name=\"target\"><String/></Member><Member name=\"channel\"><String/></Member><Member name=\"replyTarget\"><String/></Member><Member name=\"id\"><String/></Member><Member name=\"correlationId\"><String/></Member><Member name=\"sentTime\"><Type name=\"rmscore::TimeStruct\"/></Member><Member name=\"correlationTime\"><Type name=\"rmscore::TimeStruct\"/></Member><Member name=\"priority\"><Long/></Member><Member name=\"partitionNumber\"><Long/></Member><Member name=\"hostName\"><String/></Member><Member name=\"applicationName\"><String/></Member></Struct></Module><Module name=\"errorhandlermessages\"><Struct name=\"ErrorHandlerReply\"><Member name=\"header\"><Type name=\"rmscore::RmsMessageHeader\"/></Member><Member name=\"action_complete\"><Boolean/></Member></Struct></Module></MetaData>";
