#include <DatabaseUtils/DAQConfig/FEBPulserParameterSet.h>

namespace dbutils {
namespace daqconfig {

/**
 * Creates a set from the specified values.
 */
FEBPulserParameterSet::
FEBPulserParameterSet(int16_t pulserEnable, int32_t pulserPeriod,
                      int32_t pulserWidth) :
    _pulserEnable(pulserEnable), _pulserPeriod(pulserPeriod),
    _pulserWidth(pulserWidth)
{
}

/**
 * Tests if the specified set is equal to this one.
 */
bool FEBPulserParameterSet::
operator==(const FEBPulserParameterSet& other)
{
    return (other._pulserEnable == this->_pulserEnable &&
            other._pulserPeriod == this->_pulserPeriod &&
            other._pulserWidth == this->_pulserWidth);
}

/**
 * Tests if the specified set is not equal to this one.
 */
bool FEBPulserParameterSet::
operator!=(const FEBPulserParameterSet& other)
{
    return !(*this==other);
}

};  // end of namespace daqconfig
};  // end of namespace dbutils
