#include <DatabaseUtils/DAQConfig/PixelParameterListWrapper.h>
#include <stdint.h>  /* uint32_t */

namespace dbutils {
namespace daqconfig {

/**
 * Creates a wrapper instance from the specified list.
 */
PixelParameterListWrapper::
PixelParameterListWrapper(boost::shared_ptr<std::vector<int16_t> > listPtr) :
    _listPtr(listPtr)
{
}

/**
 * Tests if the specified list is equal to this one.
 */
bool PixelParameterListWrapper::
operator==(const PixelParameterListWrapper& other)
{
    std::vector<int16_t> thisList = *_listPtr;
    std::vector<int16_t> otherList = *other._listPtr;

    if (otherList.size() != thisList.size()) {
        return false;
    }

    for (uint32_t idx = 0; idx < thisList.size(); ++idx) {
        if (otherList[idx] != thisList[idx]) {
            return false;
        }
    }

    return true;
}

/**
 * Tests if the specified list is not equal to this one.
 */
bool PixelParameterListWrapper::
operator!=(const PixelParameterListWrapper& other)
{
    return !(*this==other);
}

};  // end of namespace daqconfig
};  // end of namespace dbutils
